<?php
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

require 'vendor/PHPMailer/PHPMailer.php';
require 'vendor/PHPMailer/SMTP.php';
require 'vendor/PHPMailer/Exception.php';

header('Content-Type: application/json');
header("Access-Control-Allow-Origin: *"); 
header("Access-Control-Allow-Methods: POST"); 
header("Access-Control-Allow-Headers: Content-Type, Authorization"); 
header("Content-Type: application/json; charset=UTF-8");

include 'config.php';

$conn = connect();

// Retrieve and sanitize input
$data = json_decode(file_get_contents("php://input"), true);

// Expecting these keys from the payment process
if (isset($data["email"]) && isset($data["name"]) && isset($data["amount"]) && isset($data["planName"]) && isset($data["transactionId"])) {
    // Retrieve and sanitize input
    $email = $conn->real_escape_string($data["email"]);
    $name = $conn->real_escape_string($data["name"]);
    $amount = $conn->real_escape_string($data["amount"]);
    $planName = $conn->real_escape_string($data["planName"]);
    $transactionId = $conn->real_escape_string($data["transactionId"]);

    // Check if email already exists
    $checkSql = "SELECT * FROM users WHERE email = '$email'";
    $result = $conn->query($checkSql);
    
    if ($result->num_rows === 0) {
        echo json_encode(["success" => false, "message" => "User not found."]);
        http_response_code(404); // Not Found
        exit();
    }

    // Verify the transaction with Paystack
    $paystackSecretKey = 'sk_test_8006cb95b26563ff895f84e2453b40e2e025e390';  // Replace with your actual Paystack secret key
    $verifyUrl = "https://api.paystack.co/transaction/verify/$transactionId";

    // Make a cURL request to verify the transaction with Paystack
    $ch = curl_init($verifyUrl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Authorization: Bearer ' . $paystackSecretKey
    ]);
    $response = curl_exec($ch);
    curl_close($ch);
    
    $data = json_decode($response, true);
    
    // Check if the transaction was successful
    if ($data['status'] && $data['data']['status'] == 'success') {
        // Insert payment record into the payments table
        $insertPaymentSql = "INSERT INTO payments (user_email, plan_name, amount, transaction_id, created_at) VALUES ('$email', '$planName', '$amount', '$transactionId', NOW())";
        if ($conn->query($insertPaymentSql) === FALSE) {
            echo json_encode(["success" => false, "message" => "Failed to record payment."]);
            http_response_code(500); // Internal Server Error
            exit();
        }

        // Send confirmation email
        $mail = new PHPMailer(true);
        try {
            // SMTP settings
            $mail->isSMTP();
            $mail->Host = 'smtp-relay.brevo.com';
            $mail->SMTPAuth = true;
            $mail->Username = 'ddegreeproject@gmail.com';
            $mail->Password = 'xsmtpsib-d219e2013a5ce1bf42ada0609e149db7e26554fb5f13d446ddf4e891909d4291-4YxQIdg7053fpGkM';
            $mail->SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS;
            $mail->Port = 587;
            
            // Recipients
            $mail->setFrom('no-reply@nde.ng', 'Institute of Management Consultants - Nigeria (IMC)');
            $mail->addAddress($email, $name);

            // Email content
            $mail->isHTML(true);
            $mail->Subject = 'Payment Confirmation';
            $mail->Body = "
                <div style='max-width: 600px; margin: auto; padding: 20px; font-family: Arial, sans-serif;'>
                    <div style='background: #e9f3ff; padding: 15px; text-align: center;'>
                        <img src='https://ddverifyme.com/api/IMCN%20Logo.png' alt='NDE Logo' style='height: 80px;'>
                    </div>
                    <div style='padding: 20px; background-color: #ffffff; border: 1px solid #e0e0e0;'>
                        <h2>Hello, {$name}</h2>
                        <p>Your payment has been successfully processed.</p>
                        <p><strong>Plan:</strong> {$planName}</p>
                        <p><strong>Amount Paid:</strong> ₦{$amount}</p>
                        <p><strong>Transaction ID:</strong> {$transactionId}</p>
                        <p>If you have any questions, feel free to contact us.</p>
                    </div>
                    <div style='background: #e9f3ff; padding: 10px; text-align: center; color: #555; font-size: 12px;'>
                        <p>&copy; 2024 Institute of Management Consultants - Nigeria (IMC). <br/> All rights reserved.</p>
                    </div>
                </div>
            ";

            // Send email
            $mail->send();
            echo json_encode(["success" => true, "message" => "Payment confirmed and email sent."]);
            http_response_code(200); // OK
        } catch (Exception $e) {
            echo json_encode(["success" => false, "message" => "Email could not be sent. Error: {$mail->ErrorInfo}"]);
            http_response_code(500); // Internal Server Error
        }
    } else {
        echo json_encode(["success" => false, "message" => "Payment verification failed."]);
        http_response_code(400); // Bad Request
    }
} else {
    echo json_encode(["success" => false, "message" => "Invalid input"]);
    http_response_code(400); // Bad Request
}

$conn->close();
?>